from ctypes import *
import usb.libloader
from _typeshed import Incomplete
from collections.abc import Generator

class _PackPolicy: ...
class _usb_descriptor_header(Structure): ...
class _usb_string_descriptor(Structure): ...
class _usb_endpoint_descriptor(Structure, _PackPolicy): ...
class _usb_interface_descriptor(Structure, _PackPolicy): ...
class _usb_interface(Structure, _PackPolicy): ...
class _usb_config_descriptor(Structure, _PackPolicy): ...
class _usb_device_descriptor(Structure, _PackPolicy): ...
class _usb_device(Structure, _PackPolicy): ...
class _usb_bus(Structure, _PackPolicy): ...

class _DeviceDescriptor:
    bLength: Incomplete
    bDescriptorType: Incomplete
    bcdUSB: Incomplete
    bDeviceClass: Incomplete
    bDeviceSubClass: Incomplete
    bDeviceProtocol: Incomplete
    bMaxPacketSize0: Incomplete
    idVendor: Incomplete
    idProduct: Incomplete
    bcdDevice: Incomplete
    iManufacturer: Incomplete
    iProduct: Incomplete
    iSerialNumber: Incomplete
    bNumConfigurations: Incomplete
    address: Incomplete
    bus: Incomplete
    port_number: Incomplete
    port_numbers: Incomplete
    speed: Incomplete
    def __init__(self, dev) -> None: ...

class _LibUSB(usb.backend.IBackend):
    def enumerate_devices(self) -> Generator[Incomplete, None, None]: ...
    def get_device_descriptor(self, dev): ...
    def get_configuration_descriptor(self, dev, config): ...
    def get_interface_descriptor(self, dev, intf, alt, config): ...
    def get_endpoint_descriptor(self, dev, ep, intf, alt, config): ...
    def open_device(self, dev): ...
    def close_device(self, dev_handle) -> None: ...
    def set_configuration(self, dev_handle, config_value) -> None: ...
    def get_configuration(self, dev_handle): ...
    def set_interface_altsetting(self, dev_handle, intf, altsetting) -> None: ...
    def claim_interface(self, dev_handle, intf) -> None: ...
    def release_interface(self, dev_handle, intf) -> None: ...
    def bulk_write(self, dev_handle, ep, intf, data, timeout): ...
    def bulk_read(self, dev_handle, ep, intf, buff, timeout): ...
    def intr_write(self, dev_handle, ep, intf, data, timeout): ...
    def intr_read(self, dev_handle, ep, intf, buff, timeout): ...
    def iso_write(self, dev_handle, ep, intf, data, timeout): ...
    def iso_read(self, dev_handle, ep, intf, buff, timeout): ...
    def ctrl_transfer(
        self, dev_handle, bmRequestType, bRequest, wValue, wIndex, data, timeout
    ): ...
    def clear_halt(self, dev_handle, ep) -> None: ...
    def reset_device(self, dev_handle) -> None: ...
    def is_kernel_driver_active(self, dev_handle, intf): ...
    def detach_kernel_driver(self, dev_handle, intf) -> None: ...

def get_backend(find_library: Incomplete | None = ...): ...
